/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is CopySent2Current.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
Components.utils.import("resource://gre/modules/Services.jsm");

//if(!de_ggbs) var de_ggbs={};  //might fail because of race condition

if (!de_ggbs_cs2c) var de_ggbs_cs2c = function(){
////////////////////////

var console = Services.console;

  var pub = {};
  //public function are define as
  //  pub.name = function(args) {...}
  //and must be called as de_ggbs_cs2c.name
  //
  //Internal functions are defined normally as
  //  function name(args) {...}
  //and are called without 'this.'

  pub.init = function() {
    console.logStringMessage('CopySent2Current: started');
    var app = Services.appinfo;
    if (app.name=="Thunderbird" && app.version>60)
      Components.utils.import("chrome://copysent2current/content/addOnAsync.js");
    else
      Components.utils.import("chrome://copysent2current/content/addOn.js");
    getAddon();

    if ("de_ggbs_CopySent2Current" in Components.interfaces) {  //TB<=60
      console.logStringMessage('CopySent2Current: with Components.interfaces.de_ggbs_CopySent2Current');
    } else {
      console.logStringMessage('CopySent2Current: without Components.interfaces.de_ggbs_CopySent2Current');
      console.logStringMessage('CopySent2Current: loading module instead');
      Components.utils.import("resource://copysent2current/copysent2current.jsm");
      try {
        pub.CS2C = new copySent2Current();
        console.logStringMessage('CopySent2Current: module loaded');
      } catch(e) {
//TODO: ALERT
        Components.utils.reportError('CopySent2Current: copysent2current.js: ALERT: module NOT loaded: '+e);
      }
    }

  }

  pub.showOptions = function() {
    var options = Services.wm.getMostRecentWindow("de-ggbs-cs2c-options"); //checks the 'windowstype'
    if (options)  //a ChromeWindow
      options.focus();
    else
      window.open("chrome://copysent2current/content/options.xul","_blank","chrome,resizable,titlebar=yes");
  }

  return pub; //return public elements
}();

// Call when the window is fully loaded, prevent racing condition
window.addEventListener("load", de_ggbs_cs2c.init, false);
